# Class Character

java.lang.Object
java.lang.Character

public final class Character extends java.lang.Object
The Character class wraps a value of the primitive type char in an object. An object of type Character contains a single field whose type is char. In addition, this class provides several methods for determining the type of a character and converting characters from uppercase to lowercase and vice versa. Character information is based on the Unicode Standard, version 3.0. However, in order to reduce footprint, by default the character property and case conversion operations in CLDC are available only for the ISO Latin-1 range of characters. Other Unicode character blocks can be supported as necessary. Since: JDK1.0, CLDC 1.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `MAX_CODE_POINT`
  Maximum code point value - `U+10FFFF`.
  `static final char`
  `MAX_HIGH_SURROGATE`
  Maximum value of a high surrogate or leading surrogate unit in UTF-16 encoding - `'?'`.
  `static final char`
  `MAX_LOW_SURROGATE`
  Maximum value of a low surrogate or trailing surrogate unit in UTF-16 encoding - `'?'`.
  `static final int`
  `MAX_RADIX`
  The maximum radix available for conversion to and from Strings.
  `static final char`
  `MAX_SURROGATE`
  Maximum value of a surrogate unit in UTF-16 encoding - `'?'`.
  `static final char`
  `MAX_VALUE`
  The constant value of this field is the largest value of type char.
  `static final int`
  `MIN_CODE_POINT`
  Minimum code point value - `U+0000`.
  `static final char`
  `MIN_HIGH_SURROGATE`
  Minimum value of a high surrogate or leading surrogate unit in UTF-16 encoding - `'?'`.
  `static final char`
  `MIN_LOW_SURROGATE`
  Minimum value of a low surrogate or trailing surrogate unit in UTF-16 encoding - `'?'`.
  `static final int`
  `MIN_RADIX`
  The minimum radix available for conversion to and from Strings.
  `static final int`
  `MIN_SUPPLEMENTARY_CODE_POINT`
  Minimum value of a supplementary code point - `U+010000`.
  `static final char`
  `MIN_SURROGATE`
  Minimum value of a surrogate unit in UTF-16 encoding - `'?'`.
  `static final char`
  `MIN_VALUE`
  The constant value of this field is the smallest value of type char.
  `static final int`
  `SIZE`
  Constant for the number of bits to represent a `char` in two's compliment form.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Character(char value)`
  Constructs a Character object and initializes it so that it represents the primitive value argument.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `charCount(int codePoint)`
  Calculates the number of `char` values required to represent the Unicode code point.
  `char`
  `charValue()`
  Returns the value of this Character object.
  `static int`
  `codePointAt(char[] seq, int index)`
  Returns the code point at the index in the `char[]`.
  `static int`
  `codePointAt(char[] seq, int index, int limit)`
  Returns the code point at the index in the `char[]` that's within the limit.
  `static int`
  `codePointAt(CharSequence seq, int index)`
  Returns the code point at the index in the `CharSequence`.
  `static int`
  `codePointBefore(char[] seq, int index)`
  Returns the Unicode code point that proceeds the `index` in the `char[]`.
  `static int`
  `codePointBefore(char[] seq, int index, int start)`
  Returns the Unicode code point that proceeds the `index` in the `char[]` and isn't less than `start`.
  `static int`
  `codePointBefore(CharSequence seq, int index)`
  Returns the Unicode code point that proceeds the `index` in the `CharSequence`.
  `static int`
  `codePointCount(char[] seq, int offset, int count)`
  Counts the number of Unicode code points in the subsequence of the `char[]`, as delineated by the `offset` and `count`.
  `static int`
  `codePointCount(CharSequence seq, int beginIndex, int endIndex)`
  Counts the number of Unicode code points in the subsequence of the `CharSequence`, as delineated by the `beginIndex` and `endIndex`.
  `static int`
  `digit(char ch, int radix)`
  Returns the numeric value of the character ch in the specified radix.
  `boolean`
  `equals(java.lang.Object obj)`
  Compares this object against the specified object.
  `int`
  `hashCode()`
  Returns a hash code for this Character.
  `static boolean`
  `isDigit(char ch)`
  Determines if the specified character is a digit.
  `static boolean`
  `isHighSurrogate(char ch)`
  A test for determining if the `char` is a high surrogate/leading surrogate unit that's used for representing supplementary characters in UTF-16 encoding.
  `static boolean`
  `isLowerCase(char ch)`
  Determines if the specified character is a lowercase character.
  `static boolean`
  `isLowSurrogate(char ch)`
  A test for determining if the `char` is a high surrogate/leading surrogate unit that's used for representing supplementary characters in UTF-16 encoding.
  `static boolean`
  `isSpace(char ch)`
  `static boolean`
  `isSpaceChar(char ch)`
  `static boolean`
  `isSupplementaryCodePoint(int codePoint)`
  A test for determining if the `codePoint` is within the supplementary code point range.
  `static boolean`
  `isSurrogatePair(char high, char low)`
  A test for determining if the `char` pair is a valid surrogate pair.
  `static boolean`
  `isUpperCase(char ch)`
  Determines if the specified character is an uppercase character.
  `static boolean`
  `isValidCodePoint(int codePoint)`
  A test for determining if the `codePoint` is a valid Unicode code point.
  `static boolean`
  `isWhitespace(char c)`
  See `#isWhitespace(int)`.
  `static boolean`
  `isWhitespace(int codePoint)`
  Returns true if the given code point is a Unicode whitespace character.
  `static int`
  `offsetByCodePoints(char[] seq, int start, int count, int index, int codePointOffset)`
  Determines the index into the `char[]` that is offset (measured in code points and specified by `codePointOffset`), from the `index` argument and is within the subsequence as delineated by `start` and `count`.
  `static int`
  `offsetByCodePoints(CharSequence seq, int index, int codePointOffset)`
  Determines the index into the `CharSequence` that is offset (measured in code points and specified by `codePointOffset`), from the `index` argument.
  `static char`
  `reverseBytes(char c)`
  Reverse the order of the first and second bytes in character
  `static char[]`
  `toChars(int codePoint)`
  Converts the Unicode code point, `codePoint`, into a UTF-16 encoded sequence that is returned as a `char[]`.
  `static int`
  `toChars(int codePoint, char[] dst, int dstIndex)`
  Converts the Unicode code point, `codePoint`, into a UTF-16 encoded sequence and copies the value(s) into the `char[]` `dst`, starting at the index `dstIndex`.
  `static int`
  `toCodePoint(char high, char low)`
  Converts a surrogate pair into a Unicode code point.
  `static char`
  `toLowerCase(char ch)`
  The given character is mapped to its lowercase equivalent; if the character has no lowercase equivalent, the character itself is returned.
  `String`
  `toString()`
  Returns a String object representing this character's value.
  `static char`
  `toTitleCase(char c)`
  `static int`
  `toTitleCase(int codePoint)`
  `static char`
  `toUpperCase(char ch)`
  Converts the character argument to uppercase; if the character has no uppercase equivalent, the character itself is returned.
  `static Character`
  `valueOf(char i)`
  Returns the object instance of i

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### MAX_RADIX

    public static final int MAX_RADIX
    The maximum radix available for conversion to and from Strings. See Also:Integer.toString(int, int), Integer.valueOf(java.lang.String), Constant Field Values
    See Also:
      - Constant Field Values

  - ### MAX_VALUE

    public static final char MAX_VALUE
    The constant value of this field is the largest value of type char. Since: JDK1.0.2 See Also:Constant Field Values
    See Also:
      - Constant Field Values

  - ### MIN_RADIX

    public static final int MIN_RADIX
    The minimum radix available for conversion to and from Strings. See Also:Integer.toString(int, int), Integer.valueOf(java.lang.String), Constant Field Values
    See Also:
      - Constant Field Values

  - ### MIN_VALUE

    public static final char MIN_VALUE
    The constant value of this field is the smallest value of type char. Since: JDK1.0.2 See Also:Constant Field Values
    See Also:
      - Constant Field Values

  - ### MIN_HIGH_SURROGATE

    public static final char MIN_HIGH_SURROGATE

    Minimum value of a high surrogate or leading surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MAX_HIGH_SURROGATE

    public static final char MAX_HIGH_SURROGATE

    Maximum value of a high surrogate or leading surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MIN_LOW_SURROGATE

    public static final char MIN_LOW_SURROGATE

    Minimum value of a low surrogate or trailing surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MAX_LOW_SURROGATE

    public static final char MAX_LOW_SURROGATE

    Maximum value of a low surrogate or trailing surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MIN_SURROGATE

    public static final char MIN_SURROGATE

    Minimum value of a surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MAX_SURROGATE

    public static final char MAX_SURROGATE

    Maximum value of a surrogate unit in UTF-16 encoding - `'?'`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MIN_SUPPLEMENTARY_CODE_POINT

    public static final int MIN_SUPPLEMENTARY_CODE_POINT

    Minimum value of a supplementary code point - `U+010000`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MIN_CODE_POINT

    public static final int MIN_CODE_POINT

    Minimum code point value - `U+0000`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### MAX_CODE_POINT

    public static final int MAX_CODE_POINT

    Maximum code point value - `U+10FFFF`.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

  - ### SIZE

    public static final int SIZE

    Constant for the number of bits to represent a `char` in two's compliment form.

    ###### Since

    1.5

    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Character

    public Character(char value)
    Constructs a Character object and initializes it so that it represents the primitive value argument. value - value for the new Character object.

- ## Method Details

  - ### charValue

    public char charValue()
    Returns the value of this Character object.

  - ### digit

    public static int digit(char ch, int radix)
    Returns the numeric value of the character ch in the specified radix.

  - ### equals

    public boolean equals(java.lang.Object obj)
    Compares this object against the specified object. The result is true if and only if the argument is not null and is a Character object that represents the same char value as this object.
    Overrides:
      `equals` in class `java.lang.Object`

  - ### hashCode

    public int hashCode()
    Returns a hash code for this Character.
    Overrides:
      `hashCode` in class `java.lang.Object`

  - ### isDigit

    public static boolean isDigit(char ch)
    Determines if the specified character is a digit.

  - ### isLowerCase

    public static boolean isLowerCase(char ch)
    Determines if the specified character is a lowercase character. Note that by default CLDC only supports the ISO Latin-1 range of characters. Of the ISO Latin-1 characters (character codes 0x0000 through 0x00FF), the following are lowercase: a b c d e f g h i j k l m n o p q r s t u v w x y z u00DF u00E0 u00E1 u00E2 u00E3 u00E4 u00E5 u00E6 u00E7 u00E8 u00E9 u00EA u00EB u00EC u00ED u00EE u00EF u00F0 u00F1 u00F2 u00F3 u00F4 u00F5 u00F6 u00F8 u00F9 u00FA u00FB u00FC u00FD u00FE u00FF

  - ### isUpperCase

    public static boolean isUpperCase(char ch)
    Determines if the specified character is an uppercase character. Note that by default CLDC only supports the ISO Latin-1 range of characters. Of the ISO Latin-1 characters (character codes 0x0000 through 0x00FF), the following are uppercase: A B C D E F G H I J K L M N O P Q R S T U V W X Y Z u00C0 u00C1 u00C2 u00C3 u00C4 u00C5 u00C6 u00C7 u00C8 u00C9 u00CA u00CB u00CC u00CD u00CE u00CF u00D0 u00D1 u00D2 u00D3 u00D4 u00D5 u00D6 u00D8 u00D9 u00DA u00DB u00DC u00DD u00DE

  - ### toLowerCase

    public static char toLowerCase(char ch)
    The given character is mapped to its lowercase equivalent; if the character has no lowercase equivalent, the character itself is returned. Note that by default CLDC only supports the ISO Latin-1 range of characters.

  - ### toString

    public String toString()
    Returns a String object representing this character's value. Converts this Character object to a string. The result is a string whose length is 1. The string's sole component is the primitive char value represented by this object.
    Overrides:
      `toString` in class `java.lang.Object`

  - ### toUpperCase

    public static char toUpperCase(char ch)
    Converts the character argument to uppercase; if the character has no uppercase equivalent, the character itself is returned. Note that by default CLDC only supports the ISO Latin-1 range of characters.

  - ### isValidCodePoint

    public static boolean isValidCodePoint(int codePoint)

    A test for determining if the `codePoint` is a valid Unicode code point.

    ###### Parameters

    - `codePoint`: The code point to test.

    ###### Returns

    A boolean value.

    ###### Since

    1.5

  - ### isSupplementaryCodePoint

    public static boolean isSupplementaryCodePoint(int codePoint)

    A test for determining if the `codePoint` is within the supplementary code point range.

    ###### Parameters

    - `codePoint`: The code point to test.

    ###### Returns

    A boolean value.

    ###### Since

    1.5

  - ### isHighSurrogate

    public static boolean isHighSurrogate(char ch)

    A test for determining if the `char` is a high surrogate/leading surrogate unit that's used for representing supplementary characters in UTF-16 encoding.

    ###### Parameters

    - `ch`: The `char` unit to test.

    ###### Returns

    A boolean value.

    ###### Since

    1.5

    ###### See also

    - #isLowSurrogate(char)

  - ### isLowSurrogate

    public static boolean isLowSurrogate(char ch)

    A test for determining if the `char` is a high surrogate/leading surrogate unit that's used for representing supplementary characters in UTF-16 encoding.

    ###### Parameters

    - `ch`: The `char` unit to test.

    ###### Returns

    A boolean value.

    ###### Since

    1.5

    ###### See also

    - #isHighSurrogate(char)

  - ### isSurrogatePair

    public static boolean isSurrogatePair(char high, char low)

    A test for determining if the `char` pair is a valid surrogate pair.

    ###### Parameters

    - `high`: The high surrogate unit to test.

    - `low`: The low surrogate unit to test.

    ###### Returns

    A boolean value.

    ###### Since

    1.5

    ###### See also

    - #isHighSurrogate(char)

    - #isLowSurrogate(char)

  - ### charCount

    public static int charCount(int codePoint)

    Calculates the number of `char` values required to represent the Unicode code point. This method only tests if the `codePoint` is greater than or equal to `0x10000`, in which case `2` is returned, otherwise `1`. To test if the code point is valid, use the `#isValidCodePoint(int)` method.

    ###### Parameters

    - `codePoint`: The code point to test.

    ###### Returns

    An `int` value of 2 or 1.

    ###### Since

    1.5

    ###### See also

    - #isValidCodePoint(int)

    - #isSupplementaryCodePoint(int)

  - ### toCodePoint

    public static int toCodePoint(char high, char low)

    Converts a surrogate pair into a Unicode code point. This method assume that the pair are valid surrogates. If the pair are NOT valid surrogates, then the result is indeterminate. The `char)` method should be used prior to this method to validate the pair.

    ###### Parameters

    - `high`: The high surrogate unit.

    - `low`: The low surrogate unit.

    ###### Returns

    The decoded code point.

    ###### Since

    1.5

    ###### See also

    - #isSurrogatePair(char, char)

  - ### codePointAt

    public static int codePointAt(CharSequence seq, int index)

    Returns the code point at the index in the `CharSequence`. If `char` unit at the index is a high-surrogate unit, the next index is less than the length of the sequence and the `char` unit at the next index is a low surrogate unit, then the code point represented by the pair is returned; otherwise the `char` unit at the index is returned.

    ###### Parameters

    - `seq`: The sequence of `char` units.

    - `index`: @param index The index into the `seq` to retrieve and convert.

    ###### Returns

    The Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if the `index` is negative or greater than or equal to `seq.length()`.

    ###### Since

    1.5

  - ### codePointAt

    public static int codePointAt(char[] seq, int index)

    Returns the code point at the index in the `char[]`. If `char` unit at the index is a high-surrogate unit, the next index is less than the length of the sequence and the `char` unit at the next index is a low surrogate unit, then the code point represented by the pair is returned; otherwise the `char` unit at the index is returned.

    ###### Parameters

    - `seq`: The sequence of `char` units.

    - `index`: @param index The index into the `seq` to retrieve and convert.

    ###### Returns

    The Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if the `index` is negative or greater than or equal to `seq.length()`.

    ###### Since

    1.5

  - ### codePointAt

    public static int codePointAt(char[] seq, int index, int limit)

    Returns the code point at the index in the `char[]` that's within the limit. If `char` unit at the index is a high-surrogate unit, the next index is less than the `limit` and the `char` unit at the next index is a low surrogate unit, then the code point represented by the pair is returned; otherwise the `char` unit at the index is returned.

    ###### Parameters

    - `seq`: The sequence of `char` units.

    - `index`: @param index The index into the `seq` to retrieve and convert.

    - `limit`: @param limit The exclusive index into the `seq` that marks the end of the units that can be used.

    ###### Returns

    The Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if the `index` is negative, greater than or equal to `limit`, `limit` is negative or `limit` is greater than the length of `seq`.

    ###### Since

    1.5

  - ### codePointBefore

    public static int codePointBefore(CharSequence seq, int index)

    Returns the Unicode code point that proceeds the `index` in the `CharSequence`. If the `char` unit at `index - 1` is within the low surrogate range, the value `index - 2` isn't negative and the `char` unit at `index - 2` is within the high surrogate range, then the supplementary code point made up of the surrogate pair is returned; otherwise, the `char` value at `index - 1` is returned.

    ###### Parameters

    - `seq`: The `CharSequence` to search.

    - `index`: The index into the `seq`.

    ###### Returns

    A Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `index` is less than 1 or greater than `seq.length()`.

    ###### Since

    1.5

  - ### codePointBefore

    public static int codePointBefore(char[] seq, int index)

    Returns the Unicode code point that proceeds the `index` in the `char[]`. If the `char` unit at `index - 1` is within the low surrogate range, the value `index - 2` isn't negative and the `char` unit at `index - 2` is within the high surrogate range, then the supplementary code point made up of the surrogate pair is returned; otherwise, the `char` value at `index - 1` is returned.

    ###### Parameters

    - `seq`: The `char[]` to search.

    - `index`: The index into the `seq`.

    ###### Returns

    A Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `index` is less than 1 or greater than `seq.length`.

    ###### Since

    1.5

  - ### codePointBefore

    public static int codePointBefore(char[] seq, int index, int start)

    Returns the Unicode code point that proceeds the `index` in the `char[]` and isn't less than `start`. If the `char` unit at `index - 1` is within the low surrogate range, the value `index - 2` isn't less than `start` and the `char` unit at `index - 2` is within the high surrogate range, then the supplementary code point made up of the surrogate pair is returned; otherwise, the `char` value at `index - 1` is returned.

    ###### Parameters

    - `seq`: The `char[]` to search.

    - `index`: The index into the `seq`.

    ###### Returns

    A Unicode code point.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `index` is less than or equal to `start`, `index` is greater than `seq.length`, `start` is not negative and `start` is greater than `seq.length`.

    ###### Since

    1.5

  - ### toChars

    public static int toChars(int codePoint, char[] dst, int dstIndex)

    Converts the Unicode code point, `codePoint`, into a UTF-16 encoded sequence and copies the value(s) into the `char[]` `dst`, starting at the index `dstIndex`.

    ###### Parameters

    - `codePoint`: The Unicode code point to encode.

    - `dst`: The `char[]` to copy the encoded value into.

    - `dstIndex`: The index to start copying into `dst`.

    ###### Returns

    Returns:

      The number of `char` value units copied into `dst`.

      ###### Throws

      - `IllegalArgumentException`: @throws IllegalArgumentException if `codePoint` is not a valid Unicode code point.

      - `NullPointerException`: if `dst` is `null`.

      - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `dstIndex` is negative, greater than or equal to `dst.length` or equals `dst.length - 1` when `codePoint` is a `supplementary code point`.

      ###### Since

      1.5

  - ### toChars

    public static char[] toChars(int codePoint)

    Converts the Unicode code point, `codePoint`, into a UTF-16 encoded sequence that is returned as a `char[]`.

    ###### Parameters

    - `codePoint`: The Unicode code point to encode.

    ###### Returns

    Returns:

      The UTF-16 encoded `char` sequence; if code point is a `supplementary code point`, then a 2 `char` array is returned, otherwise a 1 `char` array is returned.

      ###### Throws

      - `IllegalArgumentException`: @throws IllegalArgumentException if `codePoint` is not a valid Unicode code point.

      ###### Since

      1.5

  - ### codePointCount

    public static int codePointCount(CharSequence seq, int beginIndex, int endIndex)

    Counts the number of Unicode code points in the subsequence of the `CharSequence`, as delineated by the `beginIndex` and `endIndex`. Any surrogate values with missing pair values will be counted as 1 code point.

    ###### Parameters

    - `seq`: The `CharSequence` to look through.

    - `beginIndex`: The inclusive index to begin counting at.

    - `endIndex`: The exclusive index to stop counting at.

    ###### Returns

    The number of Unicode code points.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `beginIndex` is negative, greater than `seq.length()` or greater than `endIndex`.

    ###### Since

    1.5

  - ### codePointCount

    public static int codePointCount(char[] seq, int offset, int count)

    Counts the number of Unicode code points in the subsequence of the `char[]`, as delineated by the `offset` and `count`. Any surrogate values with missing pair values will be counted as 1 code point.

    ###### Parameters

    - `seq`: The `char[]` to look through.

    - `offset`: The inclusive index to begin counting at.

    - `count`: @param count The number of `char` values to look through in `seq`.

    ###### Returns

    The number of Unicode code points.

    ###### Throws

    - `NullPointerException`: if `seq` is `null`.

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `offset` or `count` is negative or if `endIndex` is greater than `seq.length`.

    ###### Since

    1.5

  - ### offsetByCodePoints

    public static int offsetByCodePoints(CharSequence seq, int index, int codePointOffset)

    Determines the index into the `CharSequence` that is offset (measured in code points and specified by `codePointOffset`), from the `index` argument.

    ###### Parameters

    - `seq`: The `CharSequence` to find the index within.

    - `index`: @param index The index to begin from, within the `CharSequence`.

    - `codePointOffset`: @param codePointOffset The number of code points to look back or forwards; may be a negative or positive value.

    ###### Returns

    Returns:

      The calculated index that is `codePointOffset` code points from `index`.

      ###### Throws

      - `NullPointerException`: if `seq` is `null`.

      - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `index` is negative, greater than `seq.length()`, there aren't enough values in `seq` after `index` or before `index` if `codePointOffset` is negative.

      ###### Since

      1.5

  - ### offsetByCodePoints

    public static int offsetByCodePoints(char[] seq, int start, int count, int index, int codePointOffset)

    Determines the index into the `char[]` that is offset (measured in code points and specified by `codePointOffset`), from the `index` argument and is within the subsequence as delineated by `start` and `count`.

    ###### Parameters

    - `seq`: The `char[]` to find the index within.

    - `index`: The index to begin from, within the `char[]`.

    - `codePointOffset`: @param codePointOffset The number of code points to look back or forwards; may be a negative or positive value.

    - `start`: @param start The inclusive index that marks the beginning of the subsequence.

    - `count`: @param count The number of `char` values to include within the subsequence.

    ###### Returns

    Returns:

      The calculated index that is `codePointOffset` code points from `index`.

      ###### Throws

      - `NullPointerException`: if `seq` is `null`.

      - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `start` or `count` is negative, `start + count` greater than `seq.length`, `index` is less than `start`, `index` is greater than `start + count` or there aren't enough values in `seq` after `index` or before `index` if `codePointOffset` is negative.

      ###### Since

      1.5

  - ### reverseBytes

    public static char reverseBytes(char c)

    Reverse the order of the first and second bytes in character

    ###### Parameters

    - `c`: the character

    ###### Returns

    the character with reordered bytes.

  - ### valueOf

    public static Character valueOf(char i)

    Returns the object instance of i

    ###### Parameters

    - `i`: the primitive

    ###### Returns

    object instance

  - ### isWhitespace

    public static boolean isWhitespace(char c)
    See `#isWhitespace(int)`.

  - ### isSpace

    public static boolean isSpace(char ch)

  - ### isSpaceChar

    public static boolean isSpaceChar(char ch)

  - ### isWhitespace

    public static boolean isWhitespace(int codePoint)
    Returns true if the given code point is a Unicode whitespace character. The exact set of characters considered as whitespace varies with Unicode version. Note that non-breaking spaces are not considered whitespace. Note also that line separators are considered whitespace; see `#isSpaceChar` for an alternative.

  - ### toTitleCase

    public static int toTitleCase(int codePoint)

  - ### toTitleCase

    public static char toTitleCase(char c)